document.addEventListener('click', (event) => {
  function getUserId() {
    const firstLevel = __initData[0]
    const secondLevelKey = Object.keys(firstLevel)[0]
    const secondLevel = firstLevel[secondLevelKey][27]
    const thirdLevelKey = Object.keys(secondLevel)[0]
    const shouldBeUserId = secondLevel[thirdLevelKey][17]
    return shouldBeUserId;
  }
  function getAPIKey() {
    // [0].qa[9].qa[32].qa[36]
    const firstLevel = __initData[0]
    const secondLevelKey = Object.keys(firstLevel)[0]
    const secondLevel = firstLevel[secondLevelKey][9]
    const thirdLevelKey = Object.keys(secondLevel)[0]
    const thirdLevel = secondLevel[thirdLevelKey][32]
    const fourthLevelKey = Object.keys(thirdLevel)[0]
    const fourthLevel = thirdLevel[fourthLevelKey][36]
    return fourthLevel;
  }
  const composedPath = event.composedPath();
  const clickedDetail = composedPath.find((elem) => elem.dataset?.target === "detail");
  if ( clickedDetail ) return;

  const found = composedPath.find((elem) => {
    const isDoc = elem.dataset?.target === "doc"
    if ( !isDoc ) return false;
    event.preventDefault();
    event.stopPropagation();
    const isVideo = !!elem.querySelector('[src^="https://drive-thirdparty.googleusercontent.com"][src*="/type/video/"]');
    return isVideo
  });
  if ( found === undefined ) return;
  const userId = getUserId();
  if ( userId === undefined ) {
    console.error("GoogleDriveSelection userId not found");
    return;
  }
  const hashFuncEntry = Object.entries(window).find(([funcName, funcBody]) => typeof funcBody === "function" && funcBody.toString().includes("SAPISIDHASH"))
  if ( hashFuncEntry === undefined ) {
    console.error("GoogleDriveSelection hashFunc not found");
    return;
  }
  const hashFuncRef = hashFuncEntry[1];
  window.JSInterface.handleVideoClick(
    JSON.stringify({
      id: found.dataset?.id,
      timestampHash: hashFuncRef([{key: "u", value: userId}]),
      hash: hashFuncRef(),
      apiKey: getAPIKey(),
    })
  );
}, true);