(function wrapper() {

  class RaveSourceBufferStub extends EventTarget {
    constructor() {
      super()
      this.appendWindowEnd = 0
      this.appendWindowStart = 0
      this.audioTracks = []
      this.buffered = 0
      this.mode = 'segments'
      this.textTracks = []
      this.timestampOffset = 0
      this.updating = true
      this.videoTracks = []
    }

    abort(){}
    appendBuffer(){}
    appendBufferAsync(){}
    appendStream(){}
    changeType(){}
    remove(){}
    removeAsync(){}
  }

  window.SourceBuffer = RaveSourceBufferStub

  class RaveMediaSourceStub extends EventTarget {
    constructor() {
      super()
      this.sourceBuffers = new SourceBufferList()
      this.activeSourceBuffers = new SourceBufferList()
      this.readyState = "open" // or maybe "ended"
      this.duration = 0
    }

    addSourceBuffer() { return new SourceBuffer() }
    clearLiveSeekableRange(){}
    endOfStream(){}
    removeSourceBuffer(){}
    setLiveSeekableRange(){}
    static isTypeSupported(){ return true }
  }

  window.MediaSource = RaveMediaSourceStub

  class RaveSourceBufferListStub extends EventTarget {
    constructor() {
      super()
      this.length = 0
    }
  }
  window.SourceBufferList = RaveSourceBufferListStub

  var originalCreateObjectURL = URL.createObjectURL

  URL.createObjectURL = function (...args) {
    if ( args[0] instanceof RaveMediaSourceStub ) {
      return ''
    } else {
      return originalCreateObjectURL(...args)
    }
  }

  return 'complete'
})()