(function () {

    if (window.Netflix && typeof window.Netflix.pageChanged === 'function') {
        var currentUrl = window.location.href;
        setInterval(function() {
             if (currentUrl != window.location.href) {
                 currentUrl = window.location.href;
                 window.Netflix.pageChanged(window.location.href);
             }
        }, 100);
    }

	var styles = document.createElement("style");
	styles.setAttribute("type", "text/css");
	styles.textContent = '[data-uia="email-form"],[data-uia="ads-plan-rich-banner"],[href*="https://netflix.shop/"] {display: none!important;}';
	document.head.appendChild(styles);

	var episodeContainers = document.getElementsByClassName("episodes");
	var actionButton = document.getElementsByClassName("action-button");
	if (episodeContainers && episodeContainers.length > 0 && actionButton && actionButton[0]) {
		actionButton[0].style.visibility = "hidden";
	}

	var form = document.querySelector("form");
	if (form) {
		form.addEventListener("submit", loginSubmitted);
	}

	function loginSubmitted(event) {
		var usernameTextfield = document.querySelector("input[name=\"userLoginId\"]");
		var passwordTextfield = document.querySelector("input[name=\"password\"]");

		if (usernameTextfield && passwordTextfield) {
			if (isEmailValid(usernameTextfield.value)) {
				if (window.Netflix) {
					window.Netflix.saveLogin(usernameTextfield.value, passwordTextfield.value);
				} else if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.JSInterface) {
					window.webkit.messageHandlers.JSInterface.postMessage(JSON.stringify({ username: usernameTextfield.value, password: passwordTextfield.value }));
				}
			} else {
				alert("netflix_phone_number_error");
				event.preventDefault();
				return false;
			}
		}

		return true;
	}

	function isEmailValid(email) {
		if (/[^@]+@[^\.]+\..+/.test(email)) {
			return true;
		} else {
			return false;
		}
	}
})();
